Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/AbstractFileRasterStoreProvider.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/AbstractFileRasterStoreProvider.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/AbstractFileRasterStoreProvider.java	(revision 43867)
@@ -0,0 +1,328 @@
+
+package org.gvsig.fmap.dal.file.bsq;
+
+import java.io.File;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import org.apache.commons.io.FilenameUtils;
+import org.cresques.cts.IProjection;
+import org.gvsig.fmap.dal.DALLocator;
+import org.gvsig.fmap.dal.DataManager;
+import org.gvsig.fmap.dal.DataServerExplorer;
+import org.gvsig.fmap.dal.DataStore;
+import org.gvsig.fmap.dal.DataStoreNotification;
+import org.gvsig.fmap.dal.FileHelper;
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.exception.InitializeException;
+import org.gvsig.fmap.dal.exception.OpenException;
+import org.gvsig.fmap.dal.exception.ReadException;
+import org.gvsig.fmap.dal.exception.ValidateDataParametersException;
+import org.gvsig.fmap.dal.fileutils.CLRFile;
+import org.gvsig.fmap.dal.fileutils.PRJFile;
+import org.gvsig.fmap.dal.fileutils.STXFile;
+import org.gvsig.fmap.dal.fileutils.WLDFile;
+import org.gvsig.fmap.dal.fileutils.spi.UtilsFile;
+import org.gvsig.fmap.dal.raster.OpenRasterStoreParameters;
+import org.gvsig.fmap.dal.raster.api.BandQuery;
+import org.gvsig.fmap.dal.raster.api.RasterQuery;
+import org.gvsig.fmap.dal.raster.spi.AbstractAwtRasterStoreProvider;
+import org.gvsig.fmap.dal.raster.spi.AbstractRasterStoreProvider;
+import org.gvsig.fmap.dal.resource.file.FileResource;
+import org.gvsig.fmap.dal.resource.spi.ResourceConsumer;
+import org.gvsig.fmap.dal.resource.spi.ResourceProvider;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemServerExplorer;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemServerExplorerParameters;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.FilesystemStoreParameters;
+import org.gvsig.fmap.dal.spi.DataStoreProviderServices;
+import org.gvsig.fmap.geom.Geometry;
+import org.gvsig.fmap.geom.primitive.Envelope;
+import org.gvsig.raster.lib.buffer.api.Buffer;
+import org.gvsig.raster.lib.buffer.api.BufferDimensions;
+import org.gvsig.raster.lib.buffer.api.BufferLocator;
+import org.gvsig.raster.lib.buffer.api.BufferManager;
+import org.gvsig.raster.lib.buffer.api.NoData;
+import org.gvsig.raster.lib.buffer.api.PageManager;
+import org.gvsig.raster.lib.buffer.api.TileStruct;
+import org.gvsig.raster.lib.buffer.api.exceptions.BufferException;
+import org.gvsig.raster.lib.buffer.spi.DefaultTileStruct;
+import org.gvsig.tools.dynobject.exception.DynFieldNotFoundException;
+import org.gvsig.tools.exception.BaseException;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+
+public abstract class AbstractFileRasterStoreProvider 
+        extends AbstractRasterStoreProvider
+        implements ResourceConsumer
+    {
+
+    private static final Logger logger = LoggerFactory.getLogger(AbstractAwtRasterStoreProvider.class);
+
+    protected Envelope envelope = null;
+    protected IProjection projection = null;
+    protected List<PageManager> pageManagers;
+    protected TileStruct tileStruct;
+    protected String storeProviderName;
+    protected String storeProviderDescription;
+    protected ResourceProvider resource;
+
+    protected WLDFile wldFile;
+    protected PRJFile prjFile;
+    protected STXFile stxFile;
+    // protected CLRFile clrFile;
+    
+    @SuppressWarnings("OverridableMethodCallInConstructor")
+    public AbstractFileRasterStoreProvider(
+        String storeProviderName, 
+        String storeProviderDescription, 
+        OpenRasterStoreParameters params,
+        DataStoreProviderServices storeServices
+        ) throws InitializeException {
+        super(
+                params,
+                storeServices,
+                FileHelper.newMetadataContainer(storeProviderName)
+        );
+        this.storeProviderName = storeProviderName;
+        this.storeProviderDescription = storeProviderDescription;
+        this.init(params, storeServices);
+    }
+    
+    protected void init(OpenRasterStoreParameters params, DataStoreProviderServices storeServices) throws InitializeException {
+        File file = this.getFile();
+        if (file == null) {
+            throw new InitializeException(
+                new NullPointerException(this.storeProviderName +" file is null"));
+        }
+
+        this.wldFile = UtilsFile.createWLDFile(this.getFile());
+        this.prjFile = UtilsFile.createPRJFile(this.getFile());
+        this.stxFile = UtilsFile.createSTXFile(this.getFile());
+        // this.clrFile = UtilsFile.createCLRFile(this.getFile());
+
+        this.projection = (IProjection) params.getDynValue(DataStore.METADATA_CRS);
+        if( this.projection==null ) {
+            this.projection = this.prjFile.getCRS();
+        }
+        
+        resource = this.createResource(
+            FileResource.NAME,
+            new Object[] { file.getAbsolutePath() }
+        );
+
+        resource.addConsumer(this);
+    }
+
+    @Override
+    public ResourceProvider getResource() {
+        return this.resource;
+    }
+
+    protected File getFile() {
+        return ((FilesystemStoreParameters)this.getParameters()).getFile();
+    }
+    
+    @Override
+    public Object getSourceId() {
+        return this.getFile();
+    }
+
+    @Override
+    public String getName() {
+        String name = this.getFile().getName();
+        return FilenameUtils.getBaseName(name);
+    }
+
+    @Override
+    public String getFullName() {
+        return this.getFile().getAbsolutePath();
+    }
+
+    @Override
+    public String getProviderName() {
+        return this.storeProviderName;
+    }
+    
+    @Override
+    public boolean closeResourceRequested(ResourceProvider resource) {
+        return true;
+    }
+
+    @Override
+    public void resourceChanged(ResourceProvider resource) {
+        this.getStoreServices().notifyChange(
+            DataStoreNotification.RESOURCE_CHANGED,
+            resource);
+    }
+
+    @Override
+    protected void doDispose() throws BaseException {
+        super.doDispose();
+    }
+    
+    @Override
+    public DataServerExplorer getExplorer() throws ReadException, ValidateDataParametersException {
+        DataManager manager = DALLocator.getDataManager();
+        FilesystemServerExplorerParameters params;
+        try {
+            params = (FilesystemServerExplorerParameters) manager
+            .createServerExplorerParameters(FilesystemServerExplorer.NAME);
+            params.setRoot(this.getFile().getParent());
+            return manager.openServerExplorer(FilesystemServerExplorer.NAME,params);
+        } catch (DataException | ValidateDataParametersException e) {
+            throw new ReadException(this.getProviderName(), e);
+        }
+
+    }
+
+    @Override
+    public BufferDimensions getDimensions() {
+        if(this.dimensions==null){
+            this.dimensions = BufferLocator.getBufferManager().createBufferDimensions(
+                    this.getRows(), 
+                    this.getColumns(), 
+                    this.getEnvelope()
+            );
+        }
+        return this.dimensions;
+    }
+
+    @Override
+    public TileStruct getTileStruct() {
+
+        List<Double> pixelSizes = new ArrayList<>();
+        Map<Integer, Double> zoomLevels = new HashMap<>();
+
+        if (this.tileStruct == null) {
+
+            tileStruct = new DefaultTileStruct();
+
+            int completeRows = getRows();
+            int completeColumns = getColumns();
+            double completePixelSizeX = envelope.getLength(Geometry.DIMENSIONS.X) / completeColumns;
+            double completePixelSizeY = envelope.getLength(Geometry.DIMENSIONS.Y) / completeRows;
+
+            int maximumLength = completeColumns;
+            int tileMaximumLength = tileStruct.getColumnsPerTile(); // tileSizeX;
+            double maximumPixelSize = completePixelSizeX;
+
+            if (completeRows * tileStruct.getRowsPerTile() > completeColumns * tileStruct.getColumnsPerTile()) {
+                maximumLength = completeRows;
+                tileMaximumLength = tileStruct.getRowsPerTile();
+                maximumPixelSize = completePixelSizeY;
+            }
+
+            double pixelSize = maximumPixelSize;
+            while (maximumLength * maximumPixelSize / pixelSize > tileMaximumLength) {
+                pixelSizes.add(pixelSize);
+                pixelSize = pixelSize * 2;
+            }
+            pixelSizes.add(pixelSize);
+            int i = 0;
+            for (int zoomLevel = pixelSizes.size() - 1; zoomLevel >= 0; zoomLevel--) {
+                zoomLevels.put(i, pixelSizes.get(zoomLevel));
+                i++;
+            }
+        }
+
+        return tileStruct;
+
+    }
+    
+    @Override
+    public Object getDynValue(String name) throws DynFieldNotFoundException {
+        switch(name) {
+            case DataStore.METADATA_CRS:
+                return this.getProjection();
+                
+            case DataStore.METADATA_ENVELOPE:
+                return this.getProjection();
+                
+            default:
+                return super.getDynValue(name);
+        }
+    }
+
+    @Override
+    public void setDynValue(String name, Object value)
+        throws DynFieldNotFoundException {
+        switch(name) {
+            case DataStore.METADATA_CRS:
+                this.projection = (IProjection) value;
+                break;
+                
+            case DataStore.METADATA_ENVELOPE:
+                this.envelope = (Envelope) value;
+                break;
+                
+            default:
+                super.setDynValue(name, value);
+                break;
+        }
+    }
+    
+    protected List<PageManager> getPageManagers() {
+        this.autoOpen();
+        return this.pageManagers;
+    }
+
+    protected IProjection getProjection() {
+        this.autoOpen();
+        return this.projection;
+    }
+
+    protected Envelope getEnvelope() {
+        this.autoOpen();
+        return this.envelope;
+    }
+    
+    @Override
+    public Buffer createBuffer(RasterQuery rasterQuery) throws BufferException {
+        BufferManager bufferManager = BufferLocator.getBufferManager();
+        int[] bandDataTypes;
+        List<PageManager> thePageManagers = new ArrayList<>();
+        NoData[] bandNoData;
+        if (rasterQuery != null && !rasterQuery.getBands().isEmpty() ) {
+            List<BandQuery> bands;
+            bands = rasterQuery.getBands();
+            bandDataTypes = new int[bands.size()];
+            bandNoData = new NoData[bands.size()];
+
+            for (BandQuery bandQuery : bands) {
+                int band = bandQuery.getBand();
+                bandDataTypes[band] = this.getBandDescriptor(band).getDataType();
+                bandNoData[band] = this.getNoData(rasterQuery, band);
+                thePageManagers.add(this.getPageManagers().get(band));
+            }
+        } else {
+            bandDataTypes = this.getDataTypes();
+            bandNoData = this.getNoDatas();
+            thePageManagers = this.getPageManagers();
+        }
+
+        Buffer buffer = bufferManager.createBuffer(
+                    this.getRows(), 
+                    this.getColumns(), 
+                    bandDataTypes, 
+                    bandNoData,
+                    this.getProjection(), 
+                    this.getEnvelope(), 
+                    thePageManagers
+            );
+
+        return buffer;    
+    }
+
+    @Override
+    public abstract void open() throws OpenException;
+    
+    @Override
+    public abstract int getBands();
+    
+    public abstract int getRows();
+    
+    public abstract int getColumns();
+    
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQFileSystemServerProvider.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQFileSystemServerProvider.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQFileSystemServerProvider.java	(revision 43867)
@@ -0,0 +1,82 @@
+/* gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright © 2007-2016 gvSIG Association
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.fmap.dal.file.bsq;
+
+import java.io.File;
+import org.apache.commons.io.FilenameUtils;
+
+import org.gvsig.fmap.dal.DataServerExplorer;
+import org.gvsig.fmap.dal.NewDataStoreParameters;
+import org.gvsig.fmap.dal.exception.CreateException;
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.serverexplorer.filesystem.impl.AbstractFilesystemServerExplorerProvider;
+
+public class BSQFileSystemServerProvider extends AbstractFilesystemServerExplorerProvider {
+
+    protected String[] fileExtensions;
+    protected boolean canCreate;
+
+    public BSQFileSystemServerProvider(
+            String name, 
+            String description, 
+            String[] fileExtensions
+        ) {
+        this(name, description, fileExtensions, false);
+    }
+    
+    public BSQFileSystemServerProvider(
+            String name, 
+            String description, 
+            String[] fileExtensions,
+            boolean canCreate
+        ) {
+        super(name, description);
+        this.fileExtensions = fileExtensions;
+        this.canCreate = canCreate;
+    }
+    
+    @Override
+    public boolean canCreate() {
+        return canCreate;
+    }
+
+    @Override
+    public NewDataStoreParameters getCreateParameters() throws DataException {
+        throw new UnsupportedOperationException();
+    }
+
+    @Override
+    public void create(NewDataStoreParameters parameters, boolean overwrite) throws CreateException {
+        throw new UnsupportedOperationException();
+    }
+        
+    @Override
+    public int getMode() {
+        return DataServerExplorer.MODE_RASTER;
+    }
+
+    @Override
+    public boolean accept(File pathname) {
+        return FilenameUtils.isExtension(pathname.getName().toLowerCase(), this.fileExtensions);
+    }
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQStoreProvider.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQStoreProvider.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/file/bsq/BSQStoreProvider.java	(revision 43867)
@@ -0,0 +1,128 @@
+/* gvSIG. Desktop Geographic Information System.
+ *
+ * Copyright © 2007-2016 gvSIG Association
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License
+ * as published by the Free Software Foundation; either version 2
+ * of the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
+ * MA  02110-1301, USA.
+ *
+ * For any additional information, do not hesitate to contact us
+ * at info AT gvsig.com, or visit our website www.gvsig.com.
+ */
+package org.gvsig.fmap.dal.file.bsq;
+
+import java.io.IOException;
+import java.util.ArrayList;
+import org.gvsig.fmap.dal.exception.InitializeException;
+import org.gvsig.fmap.dal.exception.OpenException;
+import org.gvsig.fmap.dal.fileutils.HDRFile;
+import org.gvsig.fmap.dal.fileutils.spi.UtilsFile;
+import org.gvsig.fmap.dal.raster.OpenRasterStoreParameters;
+import org.gvsig.fmap.dal.raster.spi.BandDescriptorServices;
+import org.gvsig.fmap.dal.spi.DataStoreProviderServices;
+import org.gvsig.tools.exception.BaseException;
+
+public class BSQStoreProvider extends AbstractFileRasterStoreProvider {
+
+    // https://www.qgistutorials.com/en/docs/open_bil_bip_bsq_files.html
+    // http://glcf.umd.edu/data/landcover/data.shtml
+    
+    protected HDRFile hdrFile;
+
+    @SuppressWarnings("OverridableMethodCallInConstructor")
+    public BSQStoreProvider(
+            String name,
+            String description,
+            OpenRasterStoreParameters params, 
+            DataStoreProviderServices storeServices) throws InitializeException {
+        super(
+                name,
+                description,
+                params,
+                storeServices
+        );
+        this.init(params, storeServices);
+    }
+
+    @Override
+    public int getBands() {
+        this.autoOpen();
+        return this.hdrFile.getNbands();
+    }
+
+    @Override
+    public int getRows() {
+        this.autoOpen();
+        return this.hdrFile.getNrows();
+    }
+
+    @Override
+    public int getColumns() {
+        this.autoOpen();
+        return this.hdrFile.getNcols();
+    }
+    
+    @Override
+    protected void doDispose() throws BaseException {
+        super.doDispose();
+        this.hdrFile = null;
+    }
+    
+    @Override
+    public void open() throws OpenException {
+        if ( this.hdrFile!=null ) {
+            return;
+        }
+        HDRFile theHDRFile = UtilsFile.createHDRFile(this.getFile());
+        if (!theHDRFile.isValid()) {
+            throw new OpenException(this.getProviderName(), null);
+        }
+        this.hdrFile = theHDRFile;
+        this.envelope = this.hdrFile.getEnvelope();
+        if (this.envelope == null) {
+            this.envelope = this.wldFile.getEnvelope(
+                    this.hdrFile.getNrows(),
+                    this.hdrFile.getNcols()
+            );
+        }
+        try {
+            int dataType = this.hdrFile.getDataType();
+            this.pageManagers = new ArrayList<>();
+            for (int nband = 0; nband < this.hdrFile.getNbands(); nband++) {
+                BandDescriptorServices bandDescriptor = getBandDescriptor(nband);
+                bandDescriptor.setDataType(dataType);
+                bandDescriptor.setName(String.valueOf(nband));
+                try {
+                    bandDescriptor.setDescription(this.getName()+ "- band "+nband);
+                } catch (Exception e) {
+                    bandDescriptor.setDescription("band "+nband);
+                }
+                bandDescriptor.add("X size", this.hdrFile.getNcols());
+                bandDescriptor.add("Y size", this.hdrFile.getNrows());                
+                BSQBandPageManager pageManager = new BSQBandPageManager(
+                        getFile(),
+                        nband * this.hdrFile.getBandSize(),
+                        this.hdrFile.getNrows(),
+                        this.hdrFile.getNcols(),
+                        dataType
+                );
+                this.pageManagers.add(pageManager);
+            }
+        } catch (IOException ex) {
+            this.hdrFile = null;
+            throw new OpenException(storeProviderName, ex);
+        }
+    }
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/WLDFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/WLDFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/WLDFile.java	(revision 43867)
@@ -0,0 +1,45 @@
+
+package org.gvsig.fmap.dal.fileutils;
+
+import org.gvsig.fmap.geom.primitive.Envelope;
+
+
+public interface WLDFile extends AuxFile {
+
+    String FILE_EXTENSION = "wld";
+
+    Envelope getEnvelope(int rows, int columns);
+
+    void setValue(Envelope envelope, int rows, int columns);
+
+    /**
+     * @return the pixelSizeX
+     */
+    double getPixelSizeX();
+
+    /**
+     * @return the pixelSizeY
+     */
+    double getPixelSizeY();
+
+    /**
+     * @return the rotationAxisX
+     */
+    double getRotationAxisX();
+
+    /**
+     * @return the rotationAxisY
+     */
+    double getRotationAxisY();
+
+    /**
+     * @return the upperLeftPixelCenterCoordX
+     */
+    double getUpperLeftPixelCenterCoordX();
+
+    /**
+     * @return the upperLeftPixelCenterCoordY
+     */
+    double getUpperLeftPixelCenterCoordY();
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/CPGFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/CPGFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/CPGFile.java	(revision 43867)
@@ -0,0 +1,36 @@
+
+package org.gvsig.fmap.dal.fileutils;
+
+public interface CPGFile extends AuxFile {
+
+    public String FILE_EXTENSION = "cpg";
+
+    public String getCharsetName();
+
+    public void setCharsetName(String charsetName);
+
+    /**
+     * Returns the code page corresponding to the
+     * provided charset name
+     *
+     * @param charsetName
+     * @return The code page, or 0x00 if no equivalent code page was found for
+     * the provided charsetName
+     */
+    public int toCPG(String charsetName);
+
+    public String toCPGName(String charsetName);
+
+    public String toCharsetName(String codePageName);
+
+    /**
+     * Gets the Java NIO charset name equivalent to the provided code page.
+     * Gets null if the provided code page is not recognised
+     * as a valid code
+     *
+     * @param codePage
+     * @return
+     */
+    public String toCharsetName(int codePage);
+    
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/PRJFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/PRJFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/PRJFile.java	(revision 43867)
@@ -0,0 +1,15 @@
+
+package org.gvsig.fmap.dal.fileutils;
+
+import org.cresques.cts.IProjection;
+
+
+public interface PRJFile extends AuxFile {
+
+    public String FILE_EXTENSION = "prj";
+    
+    public IProjection getCRS();
+
+    public void setCRS(IProjection crs);
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/spi/UtilsFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/spi/UtilsFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/spi/UtilsFile.java	(revision 43867)
@@ -0,0 +1,68 @@
+
+package org.gvsig.fmap.dal.fileutils.spi;
+
+import java.io.File;
+import org.gvsig.fmap.dal.fileutils.CLRFile;
+import org.gvsig.fmap.dal.fileutils.CPGFile;
+import org.gvsig.fmap.dal.fileutils.HDRFile;
+import org.gvsig.fmap.dal.fileutils.PRJFile;
+import org.gvsig.fmap.dal.fileutils.STXFile;
+import org.gvsig.fmap.dal.fileutils.WLDFile;
+import org.gvsig.fmap.dal.fileutils.impl.DefaultCLRFile;
+import org.gvsig.fmap.dal.fileutils.impl.DefaultCPGFile;
+import org.gvsig.fmap.dal.fileutils.impl.DefaultHDRFile;
+import org.gvsig.fmap.dal.fileutils.impl.DefaultPRJFile;
+import org.gvsig.fmap.dal.fileutils.impl.DefaultSTXFile;
+import org.gvsig.fmap.dal.fileutils.impl.DefaultWLDFile;
+
+public class UtilsFile {
+    
+    public static CPGFile createCFGFile() {
+        return new DefaultCPGFile();
+    }
+
+    public static CPGFile createCFGFile(File file) {
+        return new DefaultCPGFile(file);
+    }
+
+    public static HDRFile createHDRFile() {
+        return new DefaultHDRFile();
+    }
+
+    public static HDRFile createHDRFile(File file) {
+        return new DefaultHDRFile(file);
+    }
+
+    public static PRJFile createPRJFile() {
+        return new DefaultPRJFile();
+    }
+
+    public static PRJFile createPRJFile(File file) {
+        return new DefaultPRJFile(file);
+    }
+
+    public static STXFile createSTXFile() {
+        return new DefaultSTXFile();
+    }
+
+    public static STXFile createSTXFile(File file) {
+        return new DefaultSTXFile(file);
+    }
+
+    public static WLDFile createWLDFile() {
+        return new DefaultWLDFile();
+    }
+
+    public static WLDFile createWLDFile(File file) {
+        return new DefaultWLDFile(file);
+    }
+
+    public static CLRFile createCLRFile() {
+        return new DefaultCLRFile();
+    }
+
+    public static CLRFile createCLRFile(File file) {
+        return new DefaultCLRFile(file);
+    }
+
+}
Index: branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/AuxFile.java
===================================================================
--- branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/AuxFile.java	(revision 0)
+++ branches/org.gvsig.desktop-2018a/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.file/org.gvsig.fmap.dal.file.bsq/src/main/java/org/gvsig/fmap/dal/fileutils/AuxFile.java	(revision 43867)
@@ -0,0 +1,17 @@
+
+package org.gvsig.fmap.dal.fileutils;
+
+import java.io.File;
+import java.io.IOException;
+
+
+public interface AuxFile {
+ 
+    public File getFile(File file);
+
+    public File getFile();
+
+    public void read(File file) throws IOException ;
+
+    public void write(File file) throws IOException ;       
+}
